<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Config extends Controller_Site {
    public $configuration_id;
    public $customer_id;
    public $customer;

    public $product_id;
    public $product;

    public $config_template;

    public $config;

	public function action_index()
	{
        $this->customer_id = $this->request->param("customer");
        $this->product_id = $this->request->param("product");
        $this->configuration_id = $this->request->param("configuration");

        $this->config = new SngConfig();

        if (empty($this->customer_id)) { 
          $this->customer_id = $this->request->query('customer');
          if (!empty($this->customer_id)) {
            $this->request->redirect("/".$this->customer_id);
            return;
          }
        }


        if ($this->customer_id) {
            if (($this->customer = $this->config->customer($this->customer_id)) == NULL) {
              $this->customer_id = "";
              $this->request->redirect("/");
              return;
            }
        } else {
            $this->customer = null;
        }

        if ($this->product_id) {
            if (($this->product = $this->config->product($this->product_id)) == NULL) {
                $this->product_id = "";
            }
        } else {
            $this->product = null;
        }


        if ($this->configuration_id) {
            $template = $this->config->find_templates($this->customer_id, $this->product_id, $this->configuration_id);
            if (count($template) != 0) {
                $this->config_template = $template[0];
            } else {
                $this->configuration_id = "";
            }
        }

        if ($this->customer_id == null) {
            $this->select_customer();
        } else if ($this->configuration_id == null) {
            $this->select_template();
        } else if ($this->config_template != null) {
            $values = array();

            if ($this->request->method() == "POST") {
                $values = $this->request->post();

                /* Run validation */
                $validation = $this->config_template->validate($values);
                if ($validation === true) {
                    /* Look for a click on download */
                    foreach($this->config_template->targets() as $target) {
                        if (isset($values[str_replace(".", "_", $target)])) {
                            /* Generate target and download it */
                            $this->auto_render = FALSE;
                            $this->response->headers("Content-Disposition", "attachment; filename=".$target);
                            $this->response->headers("Content-Type", "text/plain; charset=utf-8");
                            $this->response->headers("Pragma", "no-cache");
                            $this->response->headers("Cache-Control", "must-revalidate, post-check=0, pre-check=0, public");
                            $this->response->headers("Expires", "0");
                            $this->response->body($this->config_template->render_target($target, $values));
                            return;
                        }
                    }

                    /* Display the confirmation and download options */
                    $v = View::factory("confirm")
                        ->set("customer_id", $this->customer_id)
                        ->set("customer", $this->customer)
                        ->set("product", $this->product)
                        ->set("product_id", $this->product_id)
                        ->set("template", $this->config_template)
                        ->set("values", $values);
                    $this->template->content = $v;
                    return;
                } else {
                    $v = View::factory("config")
                        ->set("customer_id", $this->customer_id)
                        ->set("customer", $this->customer)
                        ->set("product", $this->product)
                        ->set("product_id", $this->product_id)
                        ->set("template", $this->config_template)
                        ->set("values", $values)
                        ->set("errors", $validation);
                    $this->template->content = $v;
                    return;
                }
            } else {
                /* Load in the default values from the xml */
                foreach($this->config_template->fields() as $field) {
                    if (!empty($field->default)) {
                        $values[$field->field] = $field->default;
                    }
                }
            }

            $v = View::factory("config")
                ->set("customer_id", $this->customer_id)
                ->set("customer", $this->customer)
                ->set("product", $this->product)
                ->set("product_id", $this->product_id)
                ->set("template", $this->config_template)
                ->set("values", $values);

            $this->template->content = $v;
        } else {
            $this->response->status(404);
        }
	}

    public function select_customer()
    {
        $v = View::factory('customer_list');
        $v->set("customers", $this->config->customers());
        $this->template->content = $v;
    }

    public function select_template()
    {
        /* Find templates matching this customer (and maybe product) */
        $templates = $this->config->find_templates($this->customer_id, $this->product_id);

        /* Make a list of matching products for this customer */
        $products = array();
        foreach($templates as $template) {
            if (!array_key_exists($template->product, $products)) {
                $products[$template->product] = array("product" => $this->config->product($template->product), "templates" => array());
            }
            $products[$template->product]["templates"][] = $template;
        }

        /* Product is now structure as such:
          array("product_id" => array("product" => SngProduct, "templates" => array(SngTemplate, SngTemplate, ....))
        */

        $v = View::factory("template_list")
            ->set("customer_id", $this->customer_id)
            ->set("customer", $this->customer)
            ->set("product", $this->product)
            ->set("product_id", $this->product_id)
            ->set("products", $products);

        $this->template->content = $v;
    }

} // End Welcome
