<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Site extends Controller_Template {
	protected $m_assets;
    protected $m_component;
	protected $full_header = TRUE;
	protected $auth_required = FALSE;
	protected $secure_actions = FALSE;

	public function before()
	{
		parent::before();

        $this->m_assets = $media = Route::get('assets');
        $this->m_component = $media = Route::get('components');

		$media = array(
			$this->m_component->uri(array('component' => 'bootstrap', 'file' => 'docs/assets/css/bootstrap.css')) => "screen",
            $this->m_component->uri(array('component' => 'bootstrap', 'file' => 'docs/assets/css/bootstrap-responsive.css')) => "screen",
            $this->m_assets->uri(array('file' => 'css/sacs.css')) => "screen",
		);
	
		$script = array(
            $this->m_assets->uri(array('file' => 'js/jquery-1.8.1.min.js')),
            $this->m_assets->uri(array('file' => 'js/sacs.js')),
            $this->m_component->uri(array('component' => 'bootstrap', 'file' => 'docs/assets/js/bootstrap.min.js')),
            $this->m_component->uri(array('component' => 'bootstrap', 'file' => 'docs/assets/js/bootstrap-collapse.js')),
            $this->m_component->uri(array('component' => 'bootstrap', 'file' => 'docs/assets/js/bootstrap-tooltip.js')),
            $this->m_component->uri(array('component' => 'bootstrap', 'file' => 'docs/assets/js/bootstrap-popover.js')),
		);

		$this->template->content = "";
		$this->template->styles = $media;
		$this->template->scripts = $script;
        $this->template->logo_url = $this->m_assets->uri(array('file' => 'img/Sangoma_RGB.png'));
	}		

	protected function serve_static_file($file)
	{
        // Find the file extension
        $ext = pathinfo($file, PATHINFO_EXTENSION);

		if (file_exists($file)) {
			// Check if the browser sent an "if-none-match: <etag>" header, and tell if the file hasn't changed
			$this->response->check_cache(sha1($this->request->uri()).filemtime($file), $this->request);
		
			// Send the file content as the response
			$this->response->body(file_get_contents($file));

			// Set the proper headers to allow caching
			$this->response->headers('content-type',  File::mime_by_ext($ext));
			$this->response->headers('last-modified', date('r', filemtime($file)));	
		} else {
			$this->response->status(404);		
		}
	}


	/* Serves an asset file located in the asset folder */
	public function action_asset()
	{
		$this->auto_render = FALSE;
		
		// Get the file path from the request
		$file = $this->request->param('file');

        // Find the file extension
        $ext = pathinfo($file, PATHINFO_EXTENSION);
        $file = DOCROOT."assets".DIRECTORY_SEPARATOR.$file;

        if (file_exists($file)) {
            $this->serve_static_file($file);
		} else {
			// Return a 404 status
			$this->response->status(404);
		}
	}

    /* Serves a file included in a component */
    public function action_component()
    {
        $this->auto_render = FALSE;

        // Get the file path from the request
        $file = $this->request->param('file');
        $component = $this->request->param('component');

        // Find the file extension
        $ext = pathinfo($file, PATHINFO_EXTENSION);
        $file = DOCROOT."components".DIRECTORY_SEPARATOR.$component.DIRECTORY_SEPARATOR.$file;

        if (file_exists($file)) {
            $this->serve_static_file($file);
        } else {
            // Return a 404 status
            $this->response->status(404);
        }
    }

    public function action_data()
    {
        $this->auto_render = FALSE;

        // Get the file path from the request
        $file = $this->request->param('file');
        $component = $this->request->param('component');

        // Find the file extension
        $ext = pathinfo($file, PATHINFO_EXTENSION);
        $file = DOCROOT."data".DIRECTORY_SEPARATOR.$component.DIRECTORY_SEPARATOR.$file;

        if (file_exists($file)) {
            $this->serve_static_file($file);
        } else {
            // Return a 404 status
            $this->response->status(404);
        }
    }
}
