<?php defined('SYSPATH') or die('No direct script access.');

class SngConfig {
	/* FIXME: use relative paths */
	private static $dataPath;

	private $m_customers = null;
	private $m_products = null;

	public static function endsWith($haystack, $needle)
	{
	 	return strlen($needle) === 0 || substr($haystack, -strlen($needle)) === $needle;
	}
  protected function sort(&$array){
    $keys = array_keys($array);
    natcasesort($keys);

    $new_array = array();
    // Build back array
    foreach($keys as $key){
      $new_array[$key] = $array[$key]; 
    }
    $array = $new_array;
  }

	protected function load_customers() 
	{
		$xml = simplexml_load_file(SngConfig::$dataPath."/customers/customers.xml");
		$customers = $xml->xpath("//customer");
		foreach ($customers as $cust_xml) {
      $c = new SngCustomer($cust_xml);
      $this->m_customers[$c->id] = $c;
		}
    $this->sort($this->m_customers);
	}

	public function customers() {
		if (!$this->m_customers) {
			$this->load_customers();
		} 

		return array_values($this->m_customers);
	}

    public function customer($id) {
        if (!$this->m_customers) {
            $this->load_customers();
        }
        $customer = isset($this->m_customers[$id]) ? $this->m_customers[$id] : null;
        if(null===$customer)
          Log::instance()->add(Log::ERROR, "Unknown customer :customer", array(':customer' => $id));
        return $customer;
    }

	protected function load_products() 
	{
		$xml = simplexml_load_file(SngConfig::$dataPath."/products/products.xml");
		$products = $xml->xpath("//product");
		foreach ($products as $prod_xml) {
      $p = new SngProduct($prod_xml);
      $this->m_products[$p->id] = $p;
		}
    $this->sort($this->m_products);
	}

	public function products() {
		if (!$this->m_products) {
			$this->load_products();
		} 

		return array_values($this->m_products);
	}

    public function product($id) {
        if (!$this->m_products) {
            $this->load_products();
        }
        $product = isset($this->m_products[$id]) ? $this->m_products[$id] : null;
        if(null===$product)
          Log::instance()->add(Log::ERROR, "Unknown product :product", array(':product' => $id));
        return $product;
    }

	protected function _find_templates($predicates) {
		/* Open every file in the template folder and look for one with a matching id */
		$dir = opendir(SngConfig::$dataPath."/templates/");

		$xpath = "/template/general/id[".implode(' and ', $predicates)."]";

		$templates = array();

		while (FALSE !== ($entry = readdir($dir))) {
			if ($entry != "." && $entry != ".." && SngConfig::endsWith($entry, ".xml")) {
				$xml = simplexml_load_file(SngConfig::$dataPath."/templates/".$entry);
				$txml = $xml->xpath($xpath);
				if (count($txml) > 0) {
					/* Found match */
					$templates[] = new SngTemplate($xml);
				}
			}
		}

		return $templates;
	}

	public function find_templates($customer = null, $product = null, $configuration = null) {
		$predicates = array();
		if ($customer != null)  $predicates[] = "@customer='$customer'";
		if ($product != null)  $predicates[] = "@product='$product'";
		if ($configuration != null)  $predicates[] = "@configuration='$configuration'";

		return $this->_find_templates($predicates);
	}

    public static function __init()  {
        SngConfig::$dataPath = DOCROOT."data".DIRECTORY_SEPARATOR;
    }
}


SngConfig::__init();
