<?php defined('SYSPATH') or die('No direct script access.');

class Valid extends Kohana_Valid {
    public static function required($value) {
        return Valid::not_empty($value);
    }

    public static function valid_ip($value) {
        return Valid::ip($value);
    }

    public static function valid_ip_or_fqdn($value) {
        if (Valid::ip($value))
            return TRUE;

        return checkdnsrr($value, "A") || checkdnsrr($value, "AAAA");
    }

    public static function greater_than($value, $n) {
        return $value > $n;
    }

    public static function less_than($value, $n) {
        return $value < $n;
    }

    public static function integer($value) {
        return intval($value) == $value;
    }

    public static function valid_email($value) {
        return Valid::email($value);
    }
}

